image: registry.gitlab.com/gdunstone/docker-buildx-qemu

services:
  - name: docker:dind
    entrypoint: ["env", "-u", "DOCKER_HOST"]
    command: ["dockerd-entrypoint.sh"]

stages:
  - build
  - test
  - release

variables:
  CI_BUILD_ARCHS_TAKES_TOO_LONG: linux/arm/v7,linux/arm64/v8,linux/amd64
  CI_BUILD_ARCHS: linux/arm64/v8,linux/amd64
  DOCKER_DRIVER: overlay2
  DOCKER_HOST: tcp://docker:2375/
  DOCKER_TLS_CERTDIR: ""
  IMAGE_ADDR: $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
  IMAGE_CACHE: $CI_REGISTRY_IMAGE/cache:$CI_COMMIT_SHA
  IMAGE_FINAL: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME
  REAL_PHP_ADDR: $CI_REGISTRY/synacksynack/opsperator/docker-php:74-20220918

build:
  stage: build
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - update-binfmts --enable
    - docker buildx create --driver docker-container --use
    - docker buildx inspect --bootstrap
  script:
    - sed -i "s|FROM opsperator/php|FROM $REAL_PHP_ADDR|" Dockerfile
    - >
        docker buildx build --platform $CI_BUILD_ARCHS \
            --cache-from=type=registry,ref=$IMAGE_CACHE \
            --cache-to=type=registry,ref=$IMAGE_CACHE \
            --build-arg=DO_UPGRADE=yes \
            --progress plain --pull --push \
            -t "$IMAGE_ADDR" .

test:
  stage: test
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  image: docker:19.03.12
  retry:
    max: 2
  script:
    - >
        docker run --user $(id -u) \
            --name testldap \
            --tmpfs /var:rw,size=65536k \
            --tmpfs /var/run:rw,size=65536k  \
            --tmpfs /run/ldap:rw,size=65536k  \
            --tmpfs /usr/local/openldap/etc/openldap:rw,size=65536k \
            --tmpfs /var/lib/ldap:rw,size=65536k \
            -e DEBUG=yesplease \
            -e DO_CYRUS=true \
            -e DO_EXPORTERS=true \
            -e DO_LEMON=true \
            -e DO_NEXTCLOUD=true \
            -e DO_POSTFIX=true \
            -e DO_SSP=true \
            -e DO_SERVICEDESK=true \
            -e DO_WHITEPAGES=true \
            -e DO_ZPUSH=true \
            -e OPENLDAP_BIND_LDAP_PORT=1389 \
            -e OPENLDAP_BIND_LDAPS_PORT=1636 \
            -e OPENLDAP_CYRUS_PASSWORD=secret4242424242 \
            -e OPENLDAP_DEBUG=yesplease \
            -e OPENLDAP_GLOBAL_ADMIN_PASSWORD=secret \
            -e OPENLDAP_INIT_DEBUG_LEVEL=256 \
            -e OPENLDAP_LEMONLDAP_PASSWORD=openldaplemonldapregularpassword \
            -e OPENLDAP_LEMONLDAP_SESSION_PASSWORD=openldaplemonldapsessionpassword \
            -e OPENLDAP_POSTFIX_PASSWORD=secret4242424242 \
            -e OPENLDAP_ROOT_DOMAIN=demo.local \
            -e OPENLDAP_ROOT_DN_SUFFIX=dc=demo,dc=local \
            -e OPENLDAP_ZPUSH_PASSWORD=secret4242424242 \
            -p 1389:1389 -p 1636:1636 \
            -d registry.gitlab.com/synacksynack/opsperator/docker-openldap:master
    - >
        docker run --name testmysql \
           -e MYSQL_DATABASE=msdb \
           -e MYSQL_PASSWORD=mspassword \
           -e MYSQL_ROOT_PASSWORD=msrootpassword \
           -e MYSQL_USER=msuser \
           -p 3306:3306 \
           -d docker.io/centos/mariadb-102-centos7:latest
    - sleep 90
    - >
        works=false;
        for try in 1 2 3;
        do
            echo "=== Test $try/3 ==="
            if docker exec testldap /bin/sh -c '/usr/local/bin/is-ready && echo OK' 2>&1 | grep OK; then
                works=true;
                break;
            elif test $try -eq 3; then
                break;
            fi;
            echo retrying in 5 seconds;
            sleep 5;
        done;
        echo "=== Container Logs ===";
        docker logs testldap;
        if $works; then
            echo "Test: OK, OpenLDAP starts and listens";
        else
            echo "Test: KO, OpenLDAP does not answer";
            exit 1;
        fi
    - docker inspect testldap
    - >
        docker inspect testldap | awk '/"IPAddress": "/{print $2}'
    - >
        docker inspect testldap | awk '/"IPAddress": "/{print $2}' | head -1
    - >
        docker inspect testldap | awk '/"IPAddress": "/{print $2}' | head -1 | cut -d'"' -f2
    - docker inspect testmysql
    - >
        docker inspect testmysql | awk '/"IPAddress": "/{print $2}'
    - >
        docker inspect testmysql | awk '/"IPAddress": "/{print $2}' | head -1
    - >
        docker inspect testmysql | awk '/"IPAddress": "/{print $2}' | head -1 | cut -d'"' -f2
    - >
        msip=`docker inspect testmysql | awk '/"IPAddress": "/{print $2}' | head -1 | cut -d'"' -f2`;
        ldapip=`docker inspect testldap | awk '/"IPAddress": "/{print $2}' | head -1 | cut -d'"' -f2`;
        echo "Working with ldap=$ldapip mysqlip=$msip";
        echo "DEBUG=yep" >.env;
        echo "MYSQL_HOST=$msip" >>.env;
        echo "OPENLDAP_BIND_PW=secret4242424242" >>.env;
        echo "OPENLDAP_HOST=$ldapip" >>.env;
        echo "OPENLDAP_PORT=1389" >>.env;
        echo "OPENLDAP_PROTO=ldap" >>.env;
    - >
        mkdir -p volume/saslauthd volume/rsyslog volume/imap volume/saslauthd2 volume/rsyslog2 volume/postfix;
        chmod -R 777 volume || sudo chmod -R 777 volume || echo meh;
    - >
        docker run --name testcyrusimapd \
            --env-file=./.env \
            -v `pwd`/volume/saslauthd:/run/saslauthd \
            -v `pwd`/volume/rsyslog:/run/rsyslog \
            -v `pwd`/volume/imap:/var/spool/imap \
            --tmpfs /var/spool/cyrus:rw,size=65536k  \
            --tmpfs /var/lib/cyrus:rw,size=65536k  \
            --tmpfs /var/lib/imap:rw,size=65536k  \
            -p 143:143 -p 993:993 -p 2400:2400 \
            -d registry.gitlab.com/synacksynack/opsperator/docker-cyrus:master \
            /start-cyrus.sh
    - >
        docker run --name testcyrussyslog \
            --env-file=./.env \
            -v `pwd`/volume/rsyslog:/run/rsyslog \
            -d registry.gitlab.com/synacksynack/opsperator/docker-cyrus:master \
            /start-syslog.sh
    - >
        docker run --name testcyrussaslauthd \
            --env-file=./.env \
            -v `pwd`/volume/saslauthd:/run/saslauthd \
            -v `pwd`/volume/rsyslog:/run/rsyslog \
            -d registry.gitlab.com/synacksynack/opsperator/docker-cyrus:master \
            /start-saslauthd.sh
    - >
        docker run --name testcyrusjob \
            --env-file=./.env \
            -v `pwd`/volume/saslauthd:/run/saslauthd \
            -v `pwd`/volume/rsyslog:/run/rsyslog \
            -v `pwd`/volume/imap:/var/spool/imap \
            -d registry.gitlab.com/synacksynack/opsperator/docker-cyrus:master \
            /run-job.sh
    - docker inspect testcyrusimapd
    - >
        docker inspect testcyrusimapd | awk '/"IPAddress": "/{print $2}'
    - >
        docker inspect testcyrusimapd | awk '/"IPAddress": "/{print $2}' | head -1
    - >
        docker inspect testcyrusimapd | awk '/"IPAddress": "/{print $2}' | head -1 | cut -d'"' -f2
    - >
        imapip=`docker inspect testcyrusimapd | awk '/"IPAddress": "/{print $2}' | head -1 | cut -d'"' -f2`;
        echo "Working with imapip=$imapip";
        echo "LMTP_HOST=$imapip" >>.env;
        echo "IMAP_HOST=$imapip" >>.env;
    - >
        docker run --name testpostfixsmtp \
            --env-file=./.env \
            -e DONT_GENERATE_MAPS=yay \
            -e LMTP_PORT=2400 \
            -v `pwd`/volume/postfix:/etc/postfix \
            -v `pwd`/volume/saslauthd2:/run/saslauthd \
            -v `pwd`/volume/rsyslog2:/run/rsyslog \
            --tmpfs /var/spool/postfix:rw,size=65536k  \
            -v `pwd`/volume/saslauthd:/var/spool/postfix/var/run/saslauthd \
            -p 25:25 -p 465:465 -p 587:587 \
            -d registry.gitlab.com/synacksynack/opsperator/docker-postfix:master \
            /start-postfix.sh
    - >
        docker run --name testpostfixsyslog \
            --env-file=./.env \
            -v `pwd`/volume/rsyslog2:/run/rsyslog \
            -d registry.gitlab.com/synacksynack/opsperator/docker-postfix:master \
            /start-syslog.sh
    - >
        docker run --name testpostfixsaslauthd \
            --env-file=./.env \
            -v `pwd`/volume/saslauthd2:/run/saslauthd \
            -v `pwd`/volume/rsyslog2:/run/rsyslog \
            -d registry.gitlab.com/synacksynack/opsperator/docker-postfix:master \
            /start-saslauthd.sh
    - >
        docker run --name testpostfixjob \
            --env-file=./.env \
            -e LMTP_PORT=2400 \
            -v `pwd`/volume/postfix:/etc/postfix \
            -v `pwd`/volume/saslauthd2:/run/saslauthd \
            -v `pwd`/volume/rsyslog2:/run/rsyslog \
            -d registry.gitlab.com/synacksynack/opsperator/docker-postfix:master \
            /run-job.sh
    - docker inspect testpostfixsmtp
    - >
        docker inspect testpostfixsmtp | awk '/"IPAddress": "/{print $2}'
    - >
        docker inspect testpostfixsmtp | awk '/"IPAddress": "/{print $2}' | head -1
    - >
        docker inspect testpostfixsmtp | awk '/"IPAddress": "/{print $2}' | head -1 | cut -d'"' -f2
    - >
        smtpip=`docker inspect testpostfixsmtp | awk '/"IPAddress": "/{print $2}' | head -1 | cut -d'"' -f2`;
        echo "Working with smtp=$smtpip";
        echo "SMTP_HOST=$smtpip" >>.env;
    - sleep 30
    - >
        docker run --name testzpush \
            --env-file=./.env \
            -e IMAP_PORT=143 \
            -e IMAP_PROTO=imap \
            -e MYSQL_DATABASE=msdb \
            -e MYSQL_PASSWORD=mspassword \
            -e MYSQL_USER=msuser \
            -e SMTP_PORT=25 \
            -e SMTP_PROTO=smtp \
            -d $IMAGE_ADDR
    - sleep 20
    - >
        works=false;
        for try in 1 2 3 4 5;
        do
            echo "=== Test $try/5 ==="
            if docker exec testzpush /bin/sh -c 'curl http://127.0.0.1:8080/' 2>&1 | grep '<title>Z-Push'; then
                works=true;
                break;
            elif test $try -eq 5; then
                break;
            fi;
            echo retrying in 10 seconds;
            sleep 10;
        done;
        echo "=== Container Logs ===";
        docker logs testcyrusjob;
        docker logs testcyrusimapd;
        docker logs testcyrussaslauthd;
        docker logs testcyrussyslog;
        docker logs testpostfixjob;
        docker logs testpostfixsmtp;
        docker logs testpostfixsaslauthd;
        docker logs testpostfixsyslog;
        docker logs testzpush;
        echo "=== Cleaning Up ===";
        docker rm -f testzpush;
        docker rm -f testmysql;
        docker rm -f testpostfixjob;
        docker rm -f testpostfixsmtp;
        docker rm -f testpostfixsaslauthd;
        docker rm -f testpostfixsyslog;
        docker rm -f testcyrusjob;
        docker rm -f testcyrusimapd;
        docker rm -f testcyrussaslauthd;
        docker rm -f testcyrussyslog;
        docker rm -f testldap;
        if $works; then
            echo "Test: OK, Z-Push starts and listens";
        else
            echo "Test: KO, Z-Push does not answer";
            exit 1;
        fi

scan:
  stage: test
  image:
    name: docker.io/aquasec/trivy
    entrypoint: [""]
  script:
    - trivy image "$IMAGE_ADDR" || echo too-bad

retag:
  stage: release
  image:
    name: quay.io/skopeo/stable
    entrypoint: [""]
  script:
    - >
        if test "$CI_COMMIT_TAG"; then
            skopeo copy --all \
                --src-creds=$CI_REGISTRY_USER:$CI_REGISTRY_PASSWORD \
                --dest-creds=$CI_REGISTRY_USER:$CI_REGISTRY_PASSWORD \
                docker://$IMAGE_ADDR docker://$CI_REGISTRY_IMAGE:$CI_COMMIT_TAG
        else
            skopeo copy \
                --dest-creds=$CI_REGISTRY_USER:$CI_REGISTRY_PASSWORD \
                --src-creds=$CI_REGISTRY_USER:$CI_REGISTRY_PASSWORD \
                docker://$IMAGE_ADDR docker://$IMAGE_FINAL
        fi

release-code:
  rules:
    - if: $CI_COMMIT_TAG
  stage: release
  image: registry.gitlab.com/gitlab-org/release-cli:latest
  release:
    name: 'Release $CI_COMMIT_TAG'
    description: '$CI_REGISTRY_IMAGE:$CI_COMMIT_TAG'
    ref: '$CI_COMMIT_TAG'
    tag_name: '$CI_COMMIT_TAG'
  script:
    - echo 'Releasing $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG'
